PF_FLIP=$80
PF_NOISE_STEP=7

e_petflip:
	
	;jsr clear_screen
	
	lda #<pf_picture_1
	sta pf_rle_src+0
	lda #>pf_picture_1
	sta pf_rle_src+1
	lda #<(pf_text+0*10)
	sta pf_text_off+0
	lda #>(pf_text+0*10)
	sta pf_text_off+1
	lda #0
	sta pf_noise_side
	lda #0*64
	sta pf_char_glyph

	jsr pf_show_pic_from_left
	jsr pf_scene_loop
	jsr pf_hide_pic
	
	lda #<pf_picture_2
	sta pf_rle_src+0
	lda #>pf_picture_2
	sta pf_rle_src+1
	lda #<(pf_text+1*10)
	sta pf_text_off+0
	lda #>(pf_text+1*10)
	sta pf_text_off+1
	lda #1
	sta pf_noise_side
	lda #1*64
	sta pf_char_glyph
	
	jsr pf_show_pic_from_right
	jsr pf_scene_loop
	jsr pf_hide_pic
	
	lda #<pf_picture_3
	sta pf_rle_src+0
	lda #>pf_picture_3
	sta pf_rle_src+1
	lda #<(pf_text+2*10)
	sta pf_text_off+0
	lda #>(pf_text+2*10)
	sta pf_text_off+1
	lda #0
	sta pf_noise_side
	lda #2*64
	sta pf_char_glyph

	jsr pf_show_pic_from_left
	jsr pf_scene_loop
	jsr pf_hide_pic
	
	jmp pf_all_three		;jsr:rts
	
	

pf_all_three_seq:

	.byte <(SCREEN+0*40+7),>(SCREEN+0*40+7),1,15,$42,$5d
	.byte <(SCREEN+0*40+7),>(SCREEN+0*40+7),1,5,$20,$20
	.byte <(SCREEN+24*40+19),>(SCREEN+24*40+19),0,20,$42,$5d
	.byte <(SCREEN+24*40+19),>(SCREEN+24*40+19),0,10,$20,$20
	.byte <(SCREEN+0*40+31),>(SCREEN+0*40+31),1,15,$42,$5d
	.byte <(SCREEN+0*40+31),>(SCREEN+0*40+31),1,5,$20,$20
	.byte 0

pf_all_three_text:

	.byte $10,$05,$12,$13,$0f,$0e,$01,$0c,$20,$05,$0c,$05,$03,$14,$12,$0f,$0e,$09,$03,$20,$14,$12,$01,$0e,$13,$01,$03,$14,$0f,$12



pf_all_three:

	lda #<pf_all_three_seq
	sta <Z_SRC+0
	lda #>pf_all_three_seq
	sta <Z_SRC+1

@lines:

	ldy #0
	lda (Z_SRC),y
	beq @lines_done
	iny
	sta <Z_DST+0
	lda (Z_SRC),y
	iny
	sta <Z_DST+1
	lda (Z_SRC),y
	iny
	sta <Z_TEMP+0
	lda (Z_SRC),y
	iny
	tax
	lda (Z_SRC),y
	iny
	sta <Z_TEMP+1
	lda (Z_SRC),y
	iny
	sta <Z_TEMP+2
	
	tya
	clc
	adc <Z_SRC+0
	sta <Z_SRC+0
	bcc :+
	inc <Z_SRC+1
:

@loop1:

	jsr wait_frame

	ldy #0
	lda <Z_TEMP+1
	sta (Z_DST),y
	iny
	iny
	lda <Z_TEMP+2
	sta (Z_DST),y
	
	lda <Z_TEMP+0
	beq @up
	
@down:

	lda <Z_DST+0
	clc
	adc #40
	sta <Z_DST+0
	bcc :+
	inc <Z_DST+1
:
	jmp @next
	
@up:

	lda <Z_DST+0
	sec
	sbc #40
	sta <Z_DST+0
	bcs :+
	dec <Z_DST+1
:

@next:

	dex
	bne @loop1

	jmp @lines
	
@lines_done:



	ldx #14
	ldy #15
	
	jsr wait_frame
	
@text:

	lda #$a0
	sta SCREEN+18*40+5,x
	sta SCREEN+18*40+5,y
	
	jsr wait_frame
	
	lda pf_all_three_text,x
	sta SCREEN+18*40+5,x
	lda pf_all_three_text,y
	sta SCREEN+18*40+5,y
	dex
	iny
	cpy #30
	bne @text

	lda #32+16
	sta pf_char_frame_0
	lda #32+16
	sta pf_char_frame_1
	lda #32+16
	sta pf_char_frame_2
	lda #0
	sta pf_char_frame_delay
	
	ldx #64+17+64

@rotate:
	
	txa
	pha
	
	lda #0*64
	sta pf_char_glyph
	
	lda pf_char_frame_0
	jsr pf_unrle_char
	
	lda #<(SCREEN+5*40+2)
	sta pf_char_pos+0
	lda #>(SCREEN+5*40+2)
	sta pf_char_pos+1

	jsr wait_frame

	jsr pf_draw_char

	lda #1*64
	sta pf_char_glyph
	
	lda pf_char_frame_1
	jsr pf_unrle_char
	
	lda #<(SCREEN+5*40+14)
	sta pf_char_pos+0
	lda #>(SCREEN+5*40+14)
	sta pf_char_pos+1
	
	jsr pf_draw_char
	
	lda #2*64
	sta pf_char_glyph
	
	lda pf_char_frame_2
	jsr pf_unrle_char
	
	lda #<(SCREEN+5*40+26)
	sta pf_char_pos+0
	lda #>(SCREEN+5*40+26)
	sta pf_char_pos+1
	
	jsr pf_draw_char
	
	
	lda pf_char_frame_0
	cmp #64+16+32+16
	bcs :+
	inc pf_char_frame_0
:
	lda pf_char_frame_delay
	cmp #16
	bcc :+
	lda pf_char_frame_1
	cmp #64+16+32+16
	bcs :+
	inc pf_char_frame_1
:
	lda pf_char_frame_delay
	cmp #32
	bcc :+
	lda pf_char_frame_2
	cmp #64+16+32+16
	bcs :+
	inc pf_char_frame_2
:

	lda pf_char_frame_delay
	bmi :+
	inc pf_char_frame_delay
:


	pla
	tax
	dex
	beq :+
	jmp @rotate
	
:
	jsr check_marker
	beq :-
	
	jmp e_fade

	
	
pf_scene_loop:

	lda pf_noise_side
	beq :+
	lda #<(256+16)
	sta pf_char_frame_dx+0
	lda #>(256+16)
	sta pf_char_frame_dx+1
	jmp :++
:
	lda #<-(256+16)
	sta pf_char_frame_dx+0
	lda #>-(256+16)
	sta pf_char_frame_dx+1
:

	lda #0
	sta pf_char_frame+0
	lda #32+16
	sta pf_char_frame+1
	
	lda #0
	sta pf_text_pos
	sta pf_text_state
	sta pf_done
	lda #39
	sta pf_text_xoff
	
@loop:

	lda pf_char_frame+1
	
	jsr pf_unrle_char

	jsr wait_frame

	jsr pf_draw_text
	
	jsr pf_draw_char
	
	lda pf_noise_side
	bne :+
	jsr pf_picture_noise_left
	jmp :++
:
	jsr pf_picture_noise_right
:
	
	lda pf_char_frame+0
	clc
	adc pf_char_frame_dx+0
	sta pf_char_frame+0
	lda pf_char_frame+1
	adc pf_char_frame_dx+1
	sta pf_char_frame+1

	lda pf_text_state
	beq @loop

	jsr check_marker
	beq :+
	lda #1
	sta pf_done
:

	lda pf_done
	beq @loop
	
	lda pf_char_frame+1
	and #63
	cmp #0+1
	bne @loop

	rts
	

	
pf_hide_pic:

	lda #25
	sta <Z_CNT
	
@loop:

	jsr wait_frame
	
	ldx #0
	ldy #36
	
@scroll:
			
	.repeat 24,I
	lda SCREEN+23*40-I*40+0,x
	sta SCREEN+24*40-I*40+0,x
	lda SCREEN+23*40-I*40+1,x
	sta SCREEN+24*40-I*40+1,x
	.endrepeat
	
	lda #$20
	sta SCREEN+0,x
	sta SCREEN+1,x
	
	.repeat 24,I
	lda SCREEN+1*40+I*40+2,y
	sta SCREEN+0*40+I*40+2,y
	lda SCREEN+1*40+I*40+3,y
	sta SCREEN+0*40+I*40+3,y
	.endrepeat
	
	lda #$20
	sta SCREEN+24*40+2,y
	sta SCREEN+24*40+3,y
	
	inx
	inx
	inx
	inx
	dey
	dey
	dey
	dey
	cpx #40
	bcs :+
	jmp @scroll
:

	dec <Z_CNT
	beq :+
	jmp @loop
:
	rts
	

	
	
	
pf_draw_text:

	lda pf_text_state
	beq :+
	rts
:

	lda pf_text_off+0
	sta <Z_SRC+0
	lda pf_text_off+1
	sta <Z_SRC+1

	lda pf_noise_side
	bne :+
	lda #<(SCREEN+15*40)
	sta <Z_DST+0
	lda #>(SCREEN+15*40)
	sta <Z_DST+1
	jmp :++
:
	lda #<(SCREEN+15*40-15)
	sta <Z_DST+0
	lda #>(SCREEN+15*40-15)
	sta <Z_DST+1
:

	ldx #0

@show:

	txa
	cmp pf_text_pos
	bcs @skip1
	
	tay
	lda (Z_SRC),y
	sta <Z_TEMP
	txa
	asl a
	clc
	adc #18
	tay
	lda <Z_TEMP
	sta (Z_DST),y
	
@skip1:

	inx
	cpx #10
	bne @show
	
	ldy pf_text_pos
	lda (Z_SRC),y
	ldy pf_text_xoff
	sta (Z_DST),y
	iny
	lda #$20
	sta (Z_DST),y

	lda pf_text_pos
	asl a
	clc
	adc #18
	sta <Z_TEMP
	
	lda pf_text_xoff
	cmp <Z_TEMP
	beq :+
	bcc :+
	dec pf_text_xoff
	rts
:

	lda #39
	sta pf_text_xoff
	lda pf_text_pos
	cmp #9
	bcs :+
	inc pf_text_pos
	rts
:
	lda #1
	sta pf_text_state
	rts

	
	
pf_draw_char_edge:

	inc pf_char_hgt
	lda pf_char_hgt
	cmp #(33-(5*2))
	bcs :+
	rts
:
	sec
	sbc #(33-(5*2))
	lsr a

	sta <Z_TEMP
	lda #5
	sec
	sbc <Z_TEMP
	
	sta <Z_TEMP
	asl a
	clc
	adc <Z_TEMP
	tax
	
	lda pf_char_pos+0
	clc
	adc #5
	sta <Z_DST+0
	lda pf_char_pos+1
	adc #0
	sta <Z_DST+1
	
	lda #10
	sta <Z_CNT
	
@loop:

	ldy #0
	lda pf_edge_zoom+0,x
	sta (Z_DST),y
	iny
	lda pf_edge_zoom+1,x
	sta (Z_DST),y
	iny
	lda pf_edge_zoom+2,x
	sta (Z_DST),y

	txa
	clc
	adc #(6*3)
	tax
	
	lda <Z_DST+0
	clc
	adc #40
	sta <Z_DST+0
	bcc :+
	inc <Z_DST+1
:
	
	dec <Z_CNT
	bne @loop
	
@done:

	rts
	
	
	
pf_show_pic_from_left:

	lda #<(SCREEN+2*40+21)
	sta pf_char_pos+0
	lda #>(SCREEN+2*40+21)
	sta pf_char_pos+1
	lda #0
	sta pf_char_hgt
	
	ldx #33
:
	txa
	pha
	
	jsr wait_frame

	jsr pf_l_scroll_right
	jsr pf_unrle_column_left
	jsr pf_draw_char_edge
	jsr pf_picture_noise_left
	
	pla
	tax
	dex
	bne :-
	
	rts
	
	
	
pf_show_pic_from_right:

	lda #<(SCREEN+2*40+6)
	sta pf_char_pos+0
	lda #>(SCREEN+2*40+6)
	sta pf_char_pos+1
	lda #0
	sta pf_char_hgt
	
	ldx #33
:
	txa
	pha
	
	jsr wait_frame

	jsr pf_r_scroll_left
	jsr pf_unrle_column_right
	jsr pf_draw_char_edge
	jsr pf_picture_noise_right
	
	pla
	tax
	dex
	bne :-
	
	rts
	
		
	
	
;A=animation frame number

Z_PF_SRC_OFF=Z_TEMP+0
Z_PF_XOFF=Z_TEMP+1
Z_PF_OFF=Z_TEMP+2
Z_PF_OFFM=Z_TEMP+3

pf_unrle_char:

	and #63
	clc
	adc pf_char_glyph
	tax
	lda pf_frame_seq_1,x
	sta pf_flip_flag

	asl a
	tax
	
	lda pf_frames_ptr+0,x
	sta <Z_SRC+0
	lda pf_frames_ptr+1,x
	sta <Z_SRC+1
		
	ldy pf_flip_flag
	bpl :+
	
	lda #<pf_tiles_flip
	sta <Z_DST+0
	lda #>pf_tiles_flip
	sta <Z_DST+1
	lda #(0-10)&255
	sta pf_xoffx
	lda #12*10
	jmp :++
:
	lda #<pf_tiles_normal
	sta <Z_DST+0
	lda #>pf_tiles_normal
	sta <Z_DST+1
	lda #10
	sta pf_xoffx
	lda #0
:
	sta <Z_PF_XOFF

	lda #0
	sta <Z_PF_SRC_OFF
	lda #13
	sta <Z_CNT
	
@loop1:

	lda <Z_PF_XOFF
	sta <Z_PF_OFF
	clc
	adc #10
	sta <Z_PF_OFFM
	
@loop2:

	ldy <Z_PF_SRC_OFF
	lda (Z_SRC),y
	iny
	sty <Z_PF_SRC_OFF
	
	tay
	and #$e0
	bne @seq
	
	tya
	and #31
	tay
	lda (Z_DST),y
	
	ldy <Z_PF_OFF
	
	.repeat 10,I
	sta PF_FLIPBUF+I,y
	.endrepeat
	
	jmp @next
	
@seq:

	lsr a
	lsr a
	lsr a
	lsr a
	lsr a
	tax
	cpx #5
	bcc :+
	inx
:

	tya
	and #31
	tay
	lda (Z_DST),y

	ldy <Z_PF_OFF

@loop3:
	
	sta PF_FLIPBUF,y
	iny
	dex
	bne @loop3

	sty <Z_PF_OFF
	
	cpy <Z_PF_OFFM
	bcc @loop2

@next:
	
	lda <Z_PF_XOFF
	clc
	adc pf_xoffx
	sta <Z_PF_XOFF

	dec <Z_CNT
	bne @loop1
	
	rts
	
	
	
pf_unrle_column_left:

	lda #<SCREEN
	sta <Z_DST+0
	lda #>SCREEN
	sta <Z_DST+1
	jmp pf_unrle_column
	
pf_unrle_column_right:

	lda #<(SCREEN+39)
	sta <Z_DST+0
	lda #>(SCREEN+39)
	sta <Z_DST+1

pf_unrle_column:

	lda pf_rle_src+0
	sta <Z_SRC+0
	lda pf_rle_src+1
	sta <Z_SRC+1
	
	lda #0
	sta <Z_CNT
	sta <Z_TEMP		;prev byte
	
@loop:

	ldy #0
	lda (Z_SRC),y
	inc <Z_SRC+0
	bne :+
	inc <Z_SRC+1
:
	cmp #$60
	bne @norle
	lda (Z_SRC),y
	inc <Z_SRC+0
	bne :+
	inc <Z_SRC+1
:
	tax
	jmp @push
	
@norle:

	sta <Z_TEMP
	ldx #1

@push:

@push1:

	lda <Z_TEMP
	sta (Z_DST),y
	lda <Z_DST+0
	clc
	adc #40
	sta <Z_DST+0
	bcc :+
	inc <Z_DST+1
:
	inc <Z_CNT
	dex
	bne @push1
	

	lda <Z_CNT
	cmp #25
	bcc @loop
	
	lda <Z_SRC+0
	sta pf_rle_src+0
	lda <Z_SRC+1
	sta pf_rle_src+1

	rts
	
	
	
pf_scroll_down_row:

	lda <Z_SRC+0
	clc
	adc #40
	sta <Z_SRC+0
	bcc :+
	inc <Z_SRC+1
:
	lda <Z_DST+0
	clc
	adc #40
	sta <Z_DST+0
	bcc :+
	inc <Z_DST+1
:

	rts
	
	
	
pf_r_scroll_left:

	lda #<(SCREEN+1)
	sta <Z_SRC+0
	lda #>(SCREEN+1)
	sta <Z_SRC+1
	lda #<(SCREEN+0)
	sta <Z_DST+0
	lda #>(SCREEN+0)
	sta <Z_DST+1
	
	ldx #25-8
	
@loop1:

	ldy #40-17
	
	;.repeat 17-1
:
	lda (Z_SRC),y
	sta (Z_DST),y
	iny
	lda (Z_SRC),y
	sta (Z_DST),y
	iny
	lda (Z_SRC),y
	sta (Z_DST),y
	iny
	lda (Z_SRC),y
	sta (Z_DST),y
	iny
	cpy #(40-17)+(17-1)
	bne :-
	;.endrepeat
	
	jsr pf_scroll_down_row

	dex
	beq :+
	jmp @loop1
:

	ldx #8
	
@loop2:

	ldy #40-33
	
	;.repeat 33-1
:
	lda (Z_SRC),y
	sta (Z_DST),y
	iny
	lda (Z_SRC),y
	sta (Z_DST),y
	iny
	lda (Z_SRC),y
	sta (Z_DST),y
	iny
	lda (Z_SRC),y
	sta (Z_DST),y
	iny
	cpy #(40-33)+(33-1)
	bne :-
	;.endrepeat
	
	jsr pf_scroll_down_row

	dex
	beq :+
	jmp @loop2
:

	rts
	
		

pf_r_scroll_right:

	lda #<(SCREEN+0)
	sta <Z_SRC+0
	lda #>(SCREEN+0)
	sta <Z_SRC+1
	lda #<(SCREEN+1)
	sta <Z_DST+0
	lda #>(SCREEN+1)
	sta <Z_DST+1
	
	ldx #25-8
	
@loop1:

	ldy #38
	
	;.repeat 17-1
:
	lda (Z_SRC),y
	sta (Z_DST),y
	dey
	cpy #38-(17-1)
	bne :-
	;.endrepeat
	lda #$20
	sta (Z_DST),y
	
	jsr pf_scroll_down_row

	dex
	beq :+
	jmp @loop1
:

	ldx #8
	
@loop2:

	ldy #38
	
	;.repeat 33-1
:
	lda (Z_SRC),y
	sta (Z_DST),y
	dey
	cpy #38-(33-1)
	bne :-
	;.endrepeat
	lda #$20
	sta (Z_DST),y
	
	jsr pf_scroll_down_row

	dex
	beq :+
	jmp @loop2
:

	rts
	
	
	
pf_l_scroll_right:

	lda #<(SCREEN+0)
	sta <Z_SRC+0
	lda #>(SCREEN+0)
	sta <Z_SRC+1
	lda #<(SCREEN+1)
	sta <Z_DST+0
	lda #>(SCREEN+1)
	sta <Z_DST+1
	
	ldx #25-8
	
@loop1:

	ldy #17-2
	
	.repeat 17-1
	lda (Z_SRC),y
	sta (Z_DST),y
	dey
	.endrepeat
	
	jsr pf_scroll_down_row

	dex
	beq :+
	jmp @loop1
:

	ldx #8
	
@loop2:

	ldy #33-2
	
	.repeat 33-1
	lda (Z_SRC),y
	sta (Z_DST),y
	dey
	.endrepeat
	
	jsr pf_scroll_down_row

	dex
	beq :+
	jmp @loop2
:

	rts
	
	

pf_l_scroll_left:

	lda #<(SCREEN+1)
	sta <Z_SRC+0
	lda #>(SCREEN+1)
	sta <Z_SRC+1
	lda #<(SCREEN+0)
	sta <Z_DST+0
	lda #>(SCREEN+0)
	sta <Z_DST+1
	
	ldx #25-8
	
@loop1:

	ldy #0
	
	.repeat 17-1
	lda (Z_SRC),y
	sta (Z_DST),y
	iny
	.endrepeat
	lda #$20
	sta (Z_DST),y
	
	jsr pf_scroll_down_row

	dex
	beq :+
	jmp @loop1
:

	ldx #8
	
@loop2:

	ldy #0
	
	.repeat 33-1
	lda (Z_SRC),y
	sta (Z_DST),y
	iny
	.endrepeat
	lda #$20
	sta (Z_DST),y
	
	jsr pf_scroll_down_row

	dex
	beq :+
	jmp @loop2
:

	rts
	
	
	
pf_picture_noise_left:

	lda #<(SCREEN+0*40)
	sta <Z_SRC+0
	lda #>(SCREEN+0*40)
	sta <Z_SRC+1
	ldy #17
	ldx #25-8
	jsr pf_picture_noise_area
	
	lda #<(SCREEN+(25-8)*40)
	sta <Z_SRC+0
	lda #>(SCREEN+(25-8)*40)
	sta <Z_SRC+1
	ldy #33
	ldx #8
	jsr pf_picture_noise_area
	
	jmp pf_picture_noise_step



pf_picture_noise_right:
		
	lda #<(SCREEN+0*40+(40-17))
	sta <Z_SRC+0
	lda #>(SCREEN+0*40+(40-17))
	sta <Z_SRC+1
	ldy #17
	ldx #25-8
	jsr pf_picture_noise_area
	
	lda #<(SCREEN+(25-8)*40+(40-33))
	sta <Z_SRC+0
	lda #>(SCREEN+(25-8)*40+(40-33))
	sta <Z_SRC+1
	ldy #33
	ldx #8
	jsr pf_picture_noise_area
	
	jmp pf_picture_noise_step



pf_picture_noise_area:

	jsr rand8
	
	sty <Z_CNT
	stx <Z_TEMP

	ldy pf_noise_off
	
@loop:

	lda (Z_SRC),y
	cmp #$20
	beq @skip
	tax
	lda chr_to_density,x
	sta <Z_TEMP+1
	eor FRAME_CNT
	eor RAND_SEED_1
	and #7
	eor <Z_TEMP+1
	cmp #2
	bcs :+
	adc #2
:
	tax
	lda density_to_chr,x
	sta (Z_SRC),y
	
@skip:

	tya
	clc
	adc #PF_NOISE_STEP
	tay
	cmp <Z_CNT
	bcc @loop
	sec
	sbc <Z_CNT
	tay
	
	lda <Z_SRC+0
	clc
	adc #40
	sta <Z_SRC+0
	bcc :+
	inc <Z_SRC+1
:

	dec <Z_TEMP
	bne @loop
	
	rts
	
	
pf_picture_noise_step:

	inc pf_noise_off
	lda pf_noise_off
	cmp #PF_NOISE_STEP
	bcc :+
	sec
	sbc #PF_NOISE_STEP
:
	sta pf_noise_off
	
	rts
	
	
	
pf_draw_char:

	lda pf_char_pos+0
	sta <Z_DST+0
	lda pf_char_pos+1
	sta <Z_DST+1
	
	ldx #0
	ldy #0
	clc
	
@loop1:

	.repeat 13,I
	lda PF_FLIPBUF+(I*10),x
	sta (Z_DST),y
	iny
	.endrepeat
	
	;clc
	tya
	adc #40-13
	tay
	bcc :+
	inc <Z_DST+1
	clc
:

	inx
	cpx #10
	bne @loop1
	
	rts
	
	
pf_text:
	.byte $20,$10,$05,$12,$13,$0f,$0e,$01,$0c,$20
	.byte $05,$0c,$05,$03,$14,$12,$0f,$0e,$09,$03
	.byte $14,$12,$01,$0e,$13,$01,$03,$14,$0f,$12

pf_edge_zoom:	;6 frames 3x10 from full height to empty
	.byte $42,$20,$5d,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
	.byte $42,$20,$5d,$5d,$20,$42,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
	.byte $42,$20,$5d,$5d,$20,$42,$48,$20,$47,$20,$20,$20,$20,$20,$20,$20,$20,$20
	.byte $42,$20,$5d,$5d,$20,$42,$48,$20,$47,$59,$20,$54,$20,$20,$20,$20,$20,$20
	.byte $42,$20,$5d,$5d,$20,$42,$48,$20,$47,$59,$20,$54,$67,$20,$65,$20,$20,$20
	.byte $42,$20,$5d,$5d,$20,$42,$48,$20,$47,$59,$20,$54,$67,$20,$65,$20,$20,$20
	.byte $42,$20,$5d,$5d,$20,$42,$48,$20,$47,$59,$20,$54,$20,$20,$20,$20,$20,$20
	.byte $42,$20,$5d,$5d,$20,$42,$48,$20,$47,$20,$20,$20,$20,$20,$20,$20,$20,$20
	.byte $42,$20,$5d,$5d,$20,$42,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
	.byte $42,$20,$5d,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20

	.include "res/petflip.s"
	
pf_picture_1:
	.incbin "res/picture_1.bin"
pf_picture_2:
	.incbin "res/picture_2.bin"
pf_picture_3:
	.incbin "res/picture_3.bin"
	

	
PF_FLIPBUF:		.res 130,0

pf_char_frame:
	.word 0
pf_char_frame_dx:
	.word 0
pf_flip_flag:
	.byte 0	
pf_xoffx:
	.byte 0
pf_rle_src:
	.word 0
pf_noise_off:
	.byte 0
pf_char_pos:
	.word 0
pf_char_hgt:
	.byte 0
pf_text_state:
	.byte 0
pf_text_xoff:
	.byte 0
pf_text_pos:
	.byte 0
pf_text_off:
	.word 0
pf_noise_side:
	.byte 0
pf_char_glyph:
	.byte 0
pf_done:
	.byte 0
pf_char_frame_0:
	.byte 0
pf_char_frame_1:
	.byte 0
pf_char_frame_2:
	.byte 0
pf_char_frame_delay:
	.byte 0