WAVES_SCENE_DURATION=(10*60)

W_SINE_BUF=$da		;has to be placed into zeropage for better speed



e_waves:

	jsr e_waves_intro
	
	jsr e_waves_wave
	
	jmp e_waves_outro		;jsr:rts

		
	
e_waves_intro:

	lda #0
	sta w_strip_off+0
	sta w_strip_off+1
	sta w_strip_off+2
	sta w_fill_frame
	
@loop:

	jsr wait_frame
	
	lda #0
	sta w_done_cnt
	sta <Z_CNT				;0 to 2
	
	lda #<SCREEN			;sy
	sta <Z_DST+0
	lda #>SCREEN
	sta <Z_DST+1
	
@draw:

	ldx <Z_CNT
	lda w_strip_off,x
	asl a
	tax
	lda w_fill_xoff+1,x		;sx_h
	sta <Z_TEMP
	lda w_fill_xoff+0,x		;sx_l
	lsr <Z_TEMP
	ror a
	lsr <Z_TEMP
	ror a
	lsr <Z_TEMP
	ror a
	tay						;tx=sx/8
	
	lda w_fill_xoff+0,x		;sx_l
	and #7
	tax						;off=sx&7
	
	lda <Z_CNT
	and #1
	bne @left
	
@right:
	
	cpy #40
	bcs @fill_r

	lda w_fill_to_right,x
	
	jsr @fill_part
		
@fill_r:

	dey
	cpy #40
	bcc @fill

	jmp @next
	
@left:

	sty <Z_TEMP
	lda #39
	sec
	sbc <Z_TEMP
	tay
	
	cpy #40
	bcs @fill_l
	
	lda w_fill_to_left,x
	
	jsr @fill_part

@fill_l:

	iny
	cpy #40
	bcs @next
	
@fill:

	ldx #5
:
	lda #$e0
	sta (Z_DST),y
	tya
	clc
	adc #40
	tay
	dex
	bne :-

@next:

	ldx <Z_CNT
	lda w_strip_off,x
	cmp #127
	bcc @inc
	inc w_done_cnt
	jmp @next1
	
@inc:

	txa
	asl a
	asl a
	asl a
	asl a
	cmp w_fill_frame
	bcs :+
	inc w_strip_off,x
:
		
@next1:

	lda <Z_DST+0
	clc
	adc #<(40*10)
	sta <Z_DST+0
	lda <Z_DST+1
	adc #>(40*10)
	sta <Z_DST+1
	
	inc <Z_CNT
	lda <Z_CNT
	cmp #3
	bcs :+
	jmp @draw
:
	
	lda w_fill_frame
	cmp #3*16
	bcs :+
	inc w_fill_frame
:

	lda w_done_cnt
	cmp #3
	bcs :+
	jmp @loop
:
	
	rts
	
@fill_part:

	sta <Z_TEMP+1
	sty <Z_TEMP+2
	lda #5
	sta <Z_TEMP+0
	
@part_r:

	lda <Z_TEMP+1
	sta (Z_DST),y
	tya
	clc
	adc #40
	tay
	dec <Z_TEMP+0
	bne @part_r
	
	ldy <Z_TEMP+2

	rts
	
	
	
e_waves_outro:

	lda #0
	sta w_strip_down_cnt
	
@loop:

	jsr wait_frame
	
	lda w_strip_down_cnt
	asl a
	tax
	lda w_strip_y+1,x		;sy
	lsr a
	lsr a
	lsr a
	tay						;ty=sy/8
	lda w_strip_y+1,x		;sy
	and #7
	tax						;off=sy&7
	
	dey
	dey
	lda #$20
	jsr @fill_line
	
	iny
	lda #$20
	jsr @fill_line
	
	iny
	lda w_strip_down,x
	jsr @fill_line
	
	iny
	txa
	clc
	adc #8
	tax
	lda w_strip_down,x
	jsr @fill_line
	
	iny
	lda w_strip_down,x
	jsr @fill_line
	
	iny
	lda w_strip_down,x
	jsr @fill_line
	
	iny
	lda w_strip_down,x
	jsr @fill_line
	
	iny
	txa
	clc
	adc #8
	tax
	lda w_strip_down,x
	jsr @fill_line
	
	lda w_strip_down_cnt
	asl a
	tax
	
	lda w_strip_y+0,x
	clc
	adc w_strip_dy+0,x
	sta w_strip_y+0,x
	lda w_strip_y+1,x
	adc w_strip_dy+1,x
	sta w_strip_y+1,x
	
	lda w_strip_dy+0,x
	clc
	adc #64
	sta w_strip_dy+0,x
	bcc :+
	inc w_strip_dy+1,x
:

	lda w_strip_dy+1,x
	cmp #>(24<<8)
	bcc @noclip
	bne @clip
	lda w_strip_dy+0,x
	cmp #>(24<<8)
	bcc @noclip
@clip:
	lda #<(24<<8)
	sta w_strip_dy+0,x
	lda #>(24<<8)
	sta w_strip_dy+1,x
@noclip:

	lda w_strip_y+1,x
	cmp #>((26*8)<<8)
	bcc @notdone
	bne @done
	lda w_strip_y+0,x
	cmp #<((26*8)<<8)
	bcc @notdone
@done:
	inc w_strip_down_cnt
@notdone:
		
	lda w_strip_down_cnt
	cmp #3
	bcs :+
	jmp @loop
:
	
	rts
	
	

@fill_line:

	cpy #25
	bcc :+
	rts
:
	sty <Z_TEMP+0
	sta <Z_TEMP+1
	
	lda scr40_table_l,y
	sta <Z_DST+0
	lda scr40_table_h,y
	sta <Z_DST+1
	
	ldy #0
	lda <Z_TEMP+1
	
	.repeat 40
	sta (Z_DST),y
	iny
	.endrepeat
	
	ldy <Z_TEMP+0
	
	rts
	

	
e_waves_wave:

	lda #0
	sta w_wave_frame+0
	sta w_wave_frame+1
	
@loop:

	lda #0
	jsr w_prepare_sine_buf
	
	;jsr wait_frame
	
	lda #<(SCREEN-2*40+0*40)
	sta <Z_DST+0
	lda #>(SCREEN-2*40+0*40)
	sta <Z_DST+1
	ldx #0*40
	jsr w_render_strip
	
	lda #1
	jsr w_prepare_sine_buf
	
	lda #<(SCREEN-2*40+5*40)
	sta <Z_DST+0
	lda #>(SCREEN-2*40+5*40)
	sta <Z_DST+1
	ldx #1*40
	jsr w_render_strip
	
	lda #2
	jsr w_prepare_sine_buf
	
	lda #<(SCREEN-2*40+10*40)
	sta <Z_DST+0
	lda #>(SCREEN-2*40+10*40)
	sta <Z_DST+1
	ldx #2*40
	jsr w_render_strip
	
	lda #3
	jsr w_prepare_sine_buf
	
	lda #<(SCREEN-2*40+15*40)
	sta <Z_DST+0
	lda #>(SCREEN-2*40+15*40)
	sta <Z_DST+1
	ldx #3*40
	jsr w_render_strip
	
	lda #4
	jsr w_prepare_sine_buf
	
	lda #<(SCREEN-2*40+20*40)
	sta <Z_DST+0
	lda #>(SCREEN-2*40+20*40)
	sta <Z_DST+1
	ldx #4*40
	jsr w_render_strip
	
	lda #5
	jsr w_prepare_sine_buf
	
	lda #<(SCREEN-2*40+25*40)
	sta <Z_DST+0
	lda #>(SCREEN-2*40+25*40)
	sta <Z_DST+1
	ldx #5*40
	jsr w_render_strip
	
	
	inc w_wave_frame+0
	bne :+
	inc w_wave_frame+1
:

	lda w_wave_frame+0
	cmp #<WAVES_SCENE_DURATION
	lda w_wave_frame+1
	sbc #>WAVES_SCENE_DURATION
	bvc :+
	eor #$80
:
	bpl @deflate
	
@inflate:

	inc w_wave_power+1
	lda w_wave_power+1
	cmp #19*8
	bcc @next
	
	lda #19*8
	sta w_wave_power+1
	
	lda w_wave_power+0
	clc
	adc #2
	sta w_wave_power+0
	cmp #19*8
	bcc @next

	lda #19*8
	sta w_wave_power+0
	
	lda w_wave_power+2
	clc
	adc #3
	sta w_wave_power+2
	cmp #19*8
	bcc @next

	lda #19*8
	sta w_wave_power+2
		
	jmp @next
	
@deflate:

	lda w_wave_power+0
	ora w_wave_power+1
	ora w_wave_power+2
	beq @done

	lda w_wave_power+2
	beq :++
	sec
	sbc #8
	bcs :+
	lda #0
:
	sta w_wave_power+2
	jmp @next
:

	lda w_wave_power+1
	beq :++
	sec
	sbc #6
	bcs :+
	lda #0
:
	sta w_wave_power+1
	jmp @next
:

	lda w_wave_power+0
	beq :++
	sec
	sbc #4
	bcs :+
	lda #0
:
	sta w_wave_power+0
:

@next:

	jmp @loop
	
@done:

	rts
	

	
;A=line 0..5

Z_ACC=Z_TEMP+0		;word

w_prepare_sine_buf:

	asl a
	pha
	tax
	lsr a
	lsr a
	tay

	lda w_wave_ptr+0,x
	sta <Z_ACC+0
	lda w_wave_ptr+1,x
	sta <Z_ACC+1
	
;	lda w_wave_dxl+0,x
;	sta @dxl_l+1
	lda w_wave_dxl+1,x
	sta @dxl_h+1

	lda w_wave_power,y
	lsr a
	lsr a
	lsr a
	tax
	lda w_multable_ptr_l,x
	sta <Z_SRC+0
	lda w_multable_ptr_h,x
	sta <Z_SRC+1
		
	ldx #0
	
	clc

@loop:

	;lda <Z_ACC+0
	;clc
;@dxl_l:
	;adc #0
	;sta <Z_ACC+0
	lda <Z_ACC+1
@dxl_h:
	adc #0
	sta <Z_ACC+1
	tay

	lda w_sintable,y
	tay
	lda (Z_SRC),y
	
	sta <W_SINE_BUF,x

	inx
	cpx #21
	bne @loop

	pla
	tax
	
	lda w_wave_ptr+0,x
	clc
	adc w_wave_dx+0,x
	sta w_wave_ptr+0,x
	lda w_wave_ptr+1,x
	adc w_wave_dx+1,x
	sta w_wave_ptr+1,x
	
	lda w_wave_dx+0,x
	clc
	adc w_wave_dxx+0,x
	sta w_wave_dx+0,x
	lda w_wave_dx+1,x
	adc w_wave_dxx+1,x
	sta w_wave_dx+1,x

	lda w_wave_dx+0,x
	cmp #<-1200
	lda w_wave_dx+1,x
	sbc #>-1200
	bvc :+
	eor #$80
:
	bpl :+
	
	lda w_wave_dxx_inv+0,x
	sta w_wave_dxx+0,x
	lda w_wave_dxx_inv+1,x
	sta w_wave_dxx+1,x
:
	
	lda w_wave_dx+0,x
	cmp #<1200
	lda w_wave_dx+1,x
	sbc #>1200
	bvc :+
	eor #$80
:
	bmi :+
	
	lda w_wave_dxx_inv+0,x
	eor #$ff
	sta w_wave_dxx+0,x
	lda w_wave_dxx_inv+1,x
	eor #$ff
	sta w_wave_dxx+1,x
:		

	rts
	
	
	
;X=column number offset for various versions of the columns (N*40)

w_render_strip:

	txa
	clc
	adc	#<w_jump_table_l
	sta <Z_SRC+0
	lda #>w_jump_table_l
	adc #0
	sta <Z_SRC+1
	
	txa
	clc
	adc #<w_jump_table_h
	sta <Z_DST+0
	lda #>w_jump_table_h
	adc #0
	sta <Z_DST+1

	ldx #0

;36*20=720 bytes

	.repeat 20,I
	
	ldy <W_SINE_BUF+I		;3
	lda (Z_SRC),y			;5+
	sta *+9					;4
	lda (Z_DST),y			;5+
	sta *+5					;4
	jsr 0					;6
	inx						;2
	
	tya						;2
	clc						;2
	adc <W_SINE_BUF+I+1		;3
	lsr a					;2
	tay						;2
	lda (Z_SRC),y			;5+
	sta *+9					;4
	lda (Z_DST),y			;5+
	sta *+5					;4
	jsr 0					;6
	inx						;2
	
	.endrepeat
	
	rts
	
	
	

w_fill_to_right:
	.byte $20,$65,$74,$75,$61,$f6,$ea,$e7

w_fill_to_left:
	.byte $20,$67,$6a,$76,$e1,$f5,$f4,$e5
	
w_strip_down:
	.byte $e0,$e3,$f7,$f8,$62,$79,$6f,$64
	.byte $e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0
	.byte $20,$63,$77,$78,$e2,$f9,$ef,$e4

w_fill_xoff:
	.word $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	.word $0000,$0000,$0005,$000b,$0011,$0017,$001d,$0023
	.word $0029,$002f,$0035,$003b,$0041,$0046,$004c,$0051
	.word $0057,$005c,$0061,$0067,$006c,$0071,$0076,$007b
	.word $0080,$0085,$008a,$008e,$0093,$0098,$009c,$00a1
	.word $00a5,$00aa,$00ae,$00b2,$00b6,$00ba,$00be,$00c2
	.word $00c6,$00ca,$00ce,$00d2,$00d6,$00d9,$00dd,$00e0
	.word $00e4,$00e7,$00ea,$00ee,$00f1,$00f4,$00f7,$00fa
	.word $00fd,$0100,$0103,$0105,$0108,$010b,$010d,$0110
	.word $0112,$0115,$0117,$0119,$011b,$011d,$011f,$0121
	.word $0123,$0125,$0127,$0129,$012b,$012c,$012e,$012f
	.word $0131,$0132,$0133,$0135,$0136,$0137,$0138,$0139
	.word $013a,$013b,$013c,$013c,$013d,$013e,$013e,$013f
	.word $013f,$0140,$0140,$0140,$0140,$0140,$0140,$0140
	
	
	.include "res/waves.s"

w_multable_ptr_l:
	.repeat 20,I
	.byte <(w_multable+I*40)
	.endrepeat
w_multable_ptr_h:
	.repeat 20,I
	.byte >(w_multable+I*40)
	.endrepeat
	
w_strip_off:		.byte 0,0,0	
w_fill_frame:		.byte 0
w_done_cnt:			.byte 0
w_strip_y:			.word (20*8)<<8,(10*8)<<8,0
w_strip_dy:			.word 0,0,0
w_strip_down_cnt:	.byte 0

w_wave_ptr:			.word 0,200,850,700,1050,1300
w_wave_dx:			.word 100,200,400,600,300,750
w_wave_dxx:			.word -10&65535,10,0,10,-10&65535,10
w_wave_power:		.byte 0,0,0
w_wave_dxl: 		.word (2048-0*100)*2,(2048-1*100)*2,(2048-2*100)*2,(2048-3*100)*2,(2048-4*100)*2,(2048-5*100)*2
w_wave_dxx_inv:		.word (20+0*5),(20+1*5),(20+2*5),(20+3*5),(20+4*5),(20+5*5)
w_wave_frame:		.word 0